# coding: utf-8

"""
    Haplotype Frequency Curation Service

    Allows to store and return haplotype frequency data

    OpenAPI spec version: 1.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.
"""

from pprint import pformat
from six import iteritems
import re


class Genotype(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, genotype_string=None, genotyping_methods=None):
        """
        Genotype - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'genotype_string': 'str',
            'genotyping_methods': 'list[GenotypeMethod]'
        }

        self.attribute_map = {
            'genotype_string': 'genotypeString',
            'genotyping_methods': 'genotypingMethods'
        }

        self._genotype_string = genotype_string
        self._genotyping_methods = genotyping_methods

    @property
    def genotype_string(self):
        """
        Gets the genotype_string of this Genotype.
        GL string of the genotype

        :return: The genotype_string of this Genotype.
        :rtype: str
        """
        return self._genotype_string

    @genotype_string.setter
    def genotype_string(self, genotype_string):
        """
        Sets the genotype_string of this Genotype.
        GL string of the genotype

        :param genotype_string: The genotype_string of this Genotype.
        :type: str
        """

        self._genotype_string = genotype_string

    @property
    def genotyping_methods(self):
        """
        Gets the genotyping_methods of this Genotype.
        Additional Information on genotype

        :return: The genotyping_methods of this Genotype.
        :rtype: list[GenotypeMethod]
        """
        return self._genotyping_methods

    @genotyping_methods.setter
    def genotyping_methods(self, genotyping_methods):
        """
        Sets the genotyping_methods of this Genotype.
        Additional Information on genotype

        :param genotyping_methods: The genotyping_methods of this Genotype.
        :type: list[GenotypeMethod]
        """

        self._genotyping_methods = genotyping_methods

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
