# coding: utf-8

"""
    Haplotype Frequency Curation Service

    Allows to store and return haplotype frequency data

    OpenAPI spec version: 1.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.
"""

from pprint import pformat
from six import iteritems
import re


class GenotypeMethod(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, method_label=None, method_value=None, method_comment=None, method_reference=None):
        """
        GenotypeMethod - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'method_label': 'str',
            'method_value': 'str',
            'method_comment': 'str',
            'method_reference': 'str'
        }

        self.attribute_map = {
            'method_label': 'methodLabel',
            'method_value': 'methodValue',
            'method_comment': 'methodComment',
            'method_reference': 'methodReference'
        }

        self._method_label = method_label
        self._method_value = method_value
        self._method_comment = method_comment
        self._method_reference = method_reference

    @property
    def method_label(self):
        """
        Gets the method_label of this GenotypeMethod.
        Type of method label

        :return: The method_label of this GenotypeMethod.
        :rtype: str
        """
        return self._method_label

    @method_label.setter
    def method_label(self, method_label):
        """
        Sets the method_label of this GenotypeMethod.
        Type of method label

        :param method_label: The method_label of this GenotypeMethod.
        :type: str
        """
        allowed_values = ["TYPING_METHOD", "TYPING_REF", "TYPING_DATE", "TYPING_IMGT_VER", "MIRING_REF"]
        if method_label not in allowed_values:
            raise ValueError(
                "Invalid value for `method_label` ({0}), must be one of {1}"
                .format(method_label, allowed_values)
            )

        self._method_label = method_label

    @property
    def method_value(self):
        """
        Gets the method_value of this GenotypeMethod.
        Value of method

        :return: The method_value of this GenotypeMethod.
        :rtype: str
        """
        return self._method_value

    @method_value.setter
    def method_value(self, method_value):
        """
        Sets the method_value of this GenotypeMethod.
        Value of method

        :param method_value: The method_value of this GenotypeMethod.
        :type: str
        """

        self._method_value = method_value

    @property
    def method_comment(self):
        """
        Gets the method_comment of this GenotypeMethod.
        Comment on method

        :return: The method_comment of this GenotypeMethod.
        :rtype: str
        """
        return self._method_comment

    @method_comment.setter
    def method_comment(self, method_comment):
        """
        Sets the method_comment of this GenotypeMethod.
        Comment on method

        :param method_comment: The method_comment of this GenotypeMethod.
        :type: str
        """

        self._method_comment = method_comment

    @property
    def method_reference(self):
        """
        Gets the method_reference of this GenotypeMethod.
        To be used to refer to an external source

        :return: The method_reference of this GenotypeMethod.
        :rtype: str
        """
        return self._method_reference

    @method_reference.setter
    def method_reference(self, method_reference):
        """
        Sets the method_reference of this GenotypeMethod.
        To be used to refer to an external source

        :param method_reference: The method_reference of this GenotypeMethod.
        :type: str
        """

        self._method_reference = method_reference

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
