# coding: utf-8

"""
    Haplotype Frequency Curation Service

    Allows to store and return haplotype frequency data

    OpenAPI spec version: 1.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.
"""

from pprint import pformat
from six import iteritems
import re


class HaplotypeFrequency(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, haplotype_string=None, frequency=None, frequency_error_list=None):
        """
        HaplotypeFrequency - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'haplotype_string': 'str',
            'frequency': 'float',
            'frequency_error_list': 'list[FrequencyError]'
        }

        self.attribute_map = {
            'haplotype_string': 'haplotypeString',
            'frequency': 'frequency',
            'frequency_error_list': 'FrequencyErrorList'
        }

        self._haplotype_string = haplotype_string
        self._frequency = frequency
        self._frequency_error_list = frequency_error_list

    @property
    def haplotype_string(self):
        """
        Gets the haplotype_string of this HaplotypeFrequency.
        GL string describing the haplotype

        :return: The haplotype_string of this HaplotypeFrequency.
        :rtype: str
        """
        return self._haplotype_string

    @haplotype_string.setter
    def haplotype_string(self, haplotype_string):
        """
        Sets the haplotype_string of this HaplotypeFrequency.
        GL string describing the haplotype

        :param haplotype_string: The haplotype_string of this HaplotypeFrequency.
        :type: str
        """

        self._haplotype_string = haplotype_string

    @property
    def frequency(self):
        """
        Gets the frequency of this HaplotypeFrequency.
        value of frequency

        :return: The frequency of this HaplotypeFrequency.
        :rtype: float
        """
        return self._frequency

    @frequency.setter
    def frequency(self, frequency):
        """
        Sets the frequency of this HaplotypeFrequency.
        value of frequency

        :param frequency: The frequency of this HaplotypeFrequency.
        :type: float
        """

        self._frequency = frequency

    @property
    def frequency_error_list(self):
        """
        Gets the frequency_error_list of this HaplotypeFrequency.
        List of frequency errors

        :return: The frequency_error_list of this HaplotypeFrequency.
        :rtype: list[FrequencyError]
        """
        return self._frequency_error_list

    @frequency_error_list.setter
    def frequency_error_list(self, frequency_error_list):
        """
        Sets the frequency_error_list of this HaplotypeFrequency.
        List of frequency errors

        :param frequency_error_list: The frequency_error_list of this HaplotypeFrequency.
        :type: list[FrequencyError]
        """

        self._frequency_error_list = frequency_error_list

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
