# coding: utf-8

"""
    Haplotype Frequency Curation Service

    Allows to store and return haplotype frequency data

    OpenAPI spec version: 1.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.
"""

from pprint import pformat
from six import iteritems
import re


class PopulationSubmissionData(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, population=None, submissions=None):
        """
        PopulationSubmissionData - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'population': 'PopulationData',
            'submissions': 'list[int]'
        }

        self.attribute_map = {
            'population': 'population',
            'submissions': 'submissions'
        }

        self._population = population
        self._submissions = submissions

    @property
    def population(self):
        """
        Gets the population of this PopulationSubmissionData.


        :return: The population of this PopulationSubmissionData.
        :rtype: PopulationData
        """
        return self._population

    @population.setter
    def population(self, population):
        """
        Sets the population of this PopulationSubmissionData.


        :param population: The population of this PopulationSubmissionData.
        :type: PopulationData
        """

        self._population = population

    @property
    def submissions(self):
        """
        Gets the submissions of this PopulationSubmissionData.
        submissions that describe the population

        :return: The submissions of this PopulationSubmissionData.
        :rtype: list[int]
        """
        return self._submissions

    @submissions.setter
    def submissions(self, submissions):
        """
        Sets the submissions of this PopulationSubmissionData.
        submissions that describe the population

        :param submissions: The submissions of this PopulationSubmissionData.
        :type: list[int]
        """

        self._submissions = submissions

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
