# coding: utf-8

"""
    Haplotype Frequency Curation Service

    Allows to store and return haplotype frequency data

    OpenAPI spec version: 1.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.
"""

from pprint import pformat
from six import iteritems
import re


class Quality(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, value=None, type_of_quality=None):
        """
        Quality - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'value': 'float',
            'type_of_quality': 'str'
        }

        self.attribute_map = {
            'value': 'value',
            'type_of_quality': 'typeOfQuality'
        }

        self._value = value
        self._type_of_quality = type_of_quality

    @property
    def value(self):
        """
        Gets the value of this Quality.
        value of quality

        :return: The value of this Quality.
        :rtype: float
        """
        return self._value

    @value.setter
    def value(self, value):
        """
        Sets the value of this Quality.
        value of quality

        :param value: The value of this Quality.
        :type: float
        """

        self._value = value

    @property
    def type_of_quality(self):
        """
        Gets the type_of_quality of this Quality.
        type of quality

        :return: The type_of_quality of this Quality.
        :rtype: str
        """
        return self._type_of_quality

    @type_of_quality.setter
    def type_of_quality(self, type_of_quality):
        """
        Sets the type_of_quality of this Quality.
        type of quality

        :param type_of_quality: The type_of_quality of this Quality.
        :type: str
        """
        allowed_values = ["DIV_LAMBDA", "DIV_50", "DIV_50_REL", "SAM_SIZE", "SAM_POP", "DIV_PGD", "DIV_HEAVY_TAIL", "RES_TRS_COUNT", "RES_TRS", "RES_SHARE_AMBIG", "RES_MISS_LOCI", "DEV_HWE", "ERR_STD", "ERR_SAMP_80_100", "SUM_FREQ_GAP", "ERR_OFFSET", "LD_MEASURE", "KFOLD_IMPUTE", "KFOLD_PRED_ACTUAL", "KFOLD_N"]
        if type_of_quality not in allowed_values:
            raise ValueError(
                "Invalid value for `type_of_quality` ({0}), must be one of {1}"
                .format(type_of_quality, allowed_values)
            )

        self._type_of_quality = type_of_quality

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
