# coding: utf-8

"""
    Haplotype Frequency Curation Service

    Allows to store and return haplotype frequency data

    OpenAPI spec version: 1.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.
"""

from pprint import pformat
from six import iteritems
import re


class ResolutionInfo(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, scope_element=None, resolution=None):
        """
        ResolutionInfo - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'scope_element': 'str',
            'resolution': 'str'
        }

        self.attribute_map = {
            'scope_element': 'scopeElement',
            'resolution': 'resolution'
        }

        self._scope_element = scope_element
        self._resolution = resolution

    @property
    def scope_element(self):
        """
        Gets the scope_element of this ResolutionInfo.


        :return: The scope_element of this ResolutionInfo.
        :rtype: str
        """
        return self._scope_element

    @scope_element.setter
    def scope_element(self, scope_element):
        """
        Sets the scope_element of this ResolutionInfo.


        :param scope_element: The scope_element of this ResolutionInfo.
        :type: str
        """

        self._scope_element = scope_element

    @property
    def resolution(self):
        """
        Gets the resolution of this ResolutionInfo.
        resolution of the data

        :return: The resolution of this ResolutionInfo.
        :rtype: str
        """
        return self._resolution

    @resolution.setter
    def resolution(self, resolution):
        """
        Sets the resolution of this ResolutionInfo.
        resolution of the data

        :param resolution: The resolution of this ResolutionInfo.
        :type: str
        """
        allowed_values = ["G", "P", "gNMDP", "gDKMS", "2-Field", "4-Field", "6-Field", "8-Field", "Serology"]
        if resolution not in allowed_values:
            raise ValueError(
                "Invalid value for `resolution` ({0}), must be one of {1}"
                .format(resolution, allowed_values)
            )

        self._resolution = resolution

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
