# coding: utf-8

"""
    Haplotype Frequency Curation Service

    Allows to store and return haplotype frequency data

    OpenAPI spec version: 1.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.
"""

from pprint import pformat
from six import iteritems
import re


class ScopeElement(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, name=None, free_name=None, type_of_scope=None):
        """
        ScopeElement - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'name': 'str',
            'free_name': 'str',
            'type_of_scope': 'str'
        }

        self.attribute_map = {
            'name': 'name',
            'free_name': 'freeName',
            'type_of_scope': 'typeOfScope'
        }

        self._name = name
        self._free_name = free_name
        self._type_of_scope = type_of_scope

    @property
    def name(self):
        """
        Gets the name of this ScopeElement.
        label name

        :return: The name of this ScopeElement.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """
        Sets the name of this ScopeElement.
        label name

        :param name: The name of this ScopeElement.
        :type: str
        """

        self._name = name

    @property
    def free_name(self):
        """
        Gets the free_name of this ScopeElement.
        label name

        :return: The free_name of this ScopeElement.
        :rtype: str
        """
        return self._free_name

    @free_name.setter
    def free_name(self, free_name):
        """
        Sets the free_name of this ScopeElement.
        label name

        :param free_name: The free_name of this ScopeElement.
        :type: str
        """

        self._free_name = free_name

    @property
    def type_of_scope(self):
        """
        Gets the type_of_scope of this ScopeElement.
        type of label

        :return: The type_of_scope of this ScopeElement.
        :rtype: str
        """
        return self._type_of_scope

    @type_of_scope.setter
    def type_of_scope(self, type_of_scope):
        """
        Sets the type_of_scope of this ScopeElement.
        type of label

        :param type_of_scope: The type_of_scope of this ScopeElement.
        :type: str
        """
        allowed_values = ["gene", "feature"]
        if type_of_scope not in allowed_values:
            raise ValueError(
                "Invalid value for `type_of_scope` ({0}), must be one of {1}"
                .format(type_of_scope, allowed_values)
            )

        self._type_of_scope = type_of_scope

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
